SystemOrganization addCategory: #'CS528-UT3Base'!

Object subclass: #UT3Board
	instanceVariableNames: 'boardMatrix boardGlobalMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables

Here are a few quick reason about why I code them that way and 

what are those magic numbers stand for.

First, the board(boardMatrix in the code) is a 9 * 9 matrix they actually don't need to be nested(although they could) because we could access it really convenient by rows and columns and we could submatrix whenever we want. 
(here is a handy list of matrix functions http://magaloma.seasidehosting.st/Collections-Unordered)

Each cell in the board, say 1 out of 81, has three status: 

0: not played yet. 
1: player 1 marked. 
2: player 2 taken. 

That boardGlobalMatrix is 3 * 3 and design to mark the winning status of the small board, 
it changes and only changes when one (of the two players) win a subarea.   
It is a global marker with global winning status overview... so is named with 'global' in it. !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/1/2013 19:23'!
checkWinningWithCol: subMatrix

	| ret1 ret2 ret3 |
	ret1 := self checkWinningWithSet: ((subMatrix atColumn: 1) asSet).
	ret2 := self checkWinningWithSet: ((subMatrix atColumn: 2) asSet).
	ret3 := self checkWinningWithSet: ((subMatrix atColumn: 3) asSet).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/1/2013 19:23'!
checkWinningWithDiagonal: subMatrix

	| ret1 ret2  |
	ret1 := self checkWinningWithSet: ((subMatrix diagonal) asSet).
	ret2 := self checkWinningWithSet: ( Set newFrom: { (subMatrix at: 1 at: 3). (subMatrix at: 2 at: 2). (subMatrix at: 3 at: 1)}  ).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[^0]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/1/2013 19:22'!
checkWinningWithRow: subMatrix

	| ret1 ret2 ret3 |
	ret1 := self checkWinningWithSet: ((subMatrix atRow: 1) asSet).
	ret2 := self checkWinningWithSet: ((subMatrix atRow: 2) asSet).
	ret3 := self checkWinningWithSet: ((subMatrix atRow: 3) asSet).
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/1/2013 19:18'!
checkWinningWithSet: aSet

	|  |
	(aSet size = 3)
	ifTrue:["judge"
		((aSet sizeFor: 1) = 3)
		ifTrue:[ ^1 ]
		ifFalse:[
			((aSet sizeFor: 2) = 3)
				ifTrue:[ ^2 ]
				ifFalse:[ ^0 ].
			]
		]! !

!UT3Board methodsFor: 'Winning Judgements' stamp: 'Oliver 7/1/2013 19:25'!
checkWinningWithSubMatrix: subMatrix

	| ret1 ret2 ret3 |
	ret1 := self checkWinningWithRow: subMatrix.
	ret2 := self checkWinningWithCol: subMatrix.
	ret3 := self checkWinningWithDiagonal: subMatrix.
	ret1 > 0 
	ifTrue:[^ret1]
	ifFalse:[ret2> 0
		ifTrue:[^ret2]
		ifFalse:[ret3 > 0
			ifTrue:[^ret3]
			ifFalse:[^0]
			]
		]! !

!UT3Board methodsFor: 'initialize-release' stamp: 'Oliver 7/1/2013 23:51'!
initialize 

	|  |
	"Main 9 * 9 game board"
	boardMatrix := Matrix new: 9.
	boardMatrix atAllPut: 0.
	"Global view of sub board winning status with 3 * 3 Matrix"
	boardGlobalMatrix := Matrix new: 3.
	boardGlobalMatrix atAllPut: 0.
	"Each cell in the board, say 1 out of 81, has three status: 
	0: not played yet. 
	1: player 1 marked. 
	2: player 2 taken. "! !

!UT3Board methodsFor: 'Play Game' stamp: 'Oliver 7/1/2013 23:49'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol

	| tempRow tempCol subMatrix ret1 |
	( (0) == boardMatrix at: aMoveRow at: aMoveCol )
	ifTrue:[ boardMatrix at: aMoveRow at: aMoveCol put: aPlayer ]
	ifFalse:[ self error: 'Player could only be 1 or 2 and one can only play in an empty slot!!'   ].
	
	tempRow := (aMoveRow - (aMoveRow % 3)) * 3 + 1.
	tempCol := (aMoveCol - (aMoveCol % 3)) * 3 + 1.
	subMatrix := boardMatrix atRows: tempRow to: (tempRow+2) columns: tempCol to: (tempCol+2).
	
	ret1 := self checkWinningWithSubMatrix: subMatrix.
	ret1 > 0
	ifTrue:[
		tempRow := (tempRow -1)/3 + 1.
		tempCol := (tempCol -1)/3 + 1.
		boardGlobalMatrix at: tempRow at: tempCol put: ret1
		]
	ifFalse:[	 "nobody wins anything in this move, so nothing to do here ATM"	]! !

Object subclass: #UT3System
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!
